## kdbg-3.2.0.gh.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(KDbg)
set(BUILD_FOR_KDE_VERSION 5 CACHE STRING "Target this version of the KDE Frameworks (5 or 6)")
set_property(CACHE BUILD_FOR_KDE_VERSION PROPERTY STRINGS 5 6)
set(_QT5_MIN_VERSION "5.15.0")
set(_QT6_MIN_VERSION "6.6.2")  # matches Ubuntu oracular (24.10)
set(_KF5_MIN_VERSION "5.101.0")
set(_KF6_MIN_VERSION "6.6.0")  # matches Ubuntu oracular (24.10)

set(KDBG_VERSION 3.2.0)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/kdbg/version.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/kdbg/version.h)

if(BUILD_FOR_KDE_VERSION EQUAL 6)
    set(KF_MIN_VERSION ${_KF6_MIN_VERSION})
    set(QT_MIN_VERSION ${_QT6_MIN_VERSION})
elseif(BUILD_FOR_KDE_VERSION EQUAL 5)
    set(KF_MIN_VERSION ${_KF5_MIN_VERSION})
    set(QT_MIN_VERSION ${_QT5_MIN_VERSION})
else()
    message(FATAL_ERROR "BUILD_FOR_KDE_VERSION must be \"5\" or \"6\" but not \"${BUILD_FOR_KDE_VERSION}\".")
endif()

find_package(ECM ${KF_MIN_VERSION} REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(FeatureSummary)

find_package(Qt${BUILD_FOR_KDE_VERSION} ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS
    Core Widgets
)
if(BUILD_FOR_KDE_VERSION EQUAL 6)
    find_package(Qt${BUILD_FOR_KDE_VERSION}Core5Compat CONFIG REQUIRED)
endif()

find_package(KF${BUILD_FOR_KDE_VERSION} ${KF_MIN_VERSION} REQUIRED COMPONENTS
    I18n
    Config
    CoreAddons
    IconThemes
    XmlGui
    WindowSystem
)

add_subdirectory(kdbg)
add_subdirectory(po)

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== kdbg/CMakeLists.txt ===
add_subdirectory(doc)
add_subdirectory(pics)
add_subdirectory(typetables)

include(CheckFunctionExists)
include(CheckIncludeFiles)
include(CheckLibraryExists)
include(ECMAddAppIcon)

CHECK_INCLUDE_FILES(pty.h HAVE_PTY_H)
CHECK_INCLUDE_FILES(libutil.h HAVE_LIBUTIL_H)
CHECK_INCLUDE_FILES(util.h HAVE_UTIL_H)
CHECK_LIBRARY_EXISTS(util openpty "" HAVE_LIB_UTIL)
if (HAVE_LIB_UTIL)
    set(CMAKE_REQUIRED_LIBRARIES util)
endif (HAVE_LIB_UTIL)
CHECK_FUNCTION_EXISTS(openpty HAVE_FUNC_OPENPTY)

message("-- Looking for a suitable 'ps' invocation")
FIND_PROGRAM(PROG_PS ps)
IF (PROG_PS)
    set(PS_ARGS -eo pid,ppid,uid,vsz,etime,time,args)
    execute_process(COMMAND ${PROG_PS} ${PS_ARGS}
		RESULT_VARIABLE PS_FAILED
		OUTPUT_QUIET ERROR_QUIET)
    IF (NOT PS_FAILED)
	execute_process(
		COMMAND ${PROG_PS} ${PS_ARGS}
		COMMAND sed -e "s/  */ /g" -e 1q
		OUTPUT_VARIABLE PS_HEADER)
	string(STRIP "${PS_HEADER}" PS_HEADER)
	IF (PS_HEADER STREQUAL "PID PPID UID VSZ ELAPSED TIME COMMAND")
	    # enclose arguments in double-quotes
	    set(PS_COMMAND \"${PROG_PS}\")
	    set(PS_MSG ${PROG_PS})
	    foreach (I ${PS_ARGS})
		set(PS_COMMAND ${PS_COMMAND},\"${I}\")
		set(PS_MSG "${PS_MSG} ${I}")
	    endforeach (I)
	    message("-- Found 'ps' command: ${PS_MSG}")
	ENDIF (PS_HEADER STREQUAL "PID PPID UID VSZ ELAPSED TIME COMMAND")
    ENDIF (NOT PS_FAILED)
ENDIF (PROG_PS)
IF (NOT PS_COMMAND)
    message("-- Looking for a suitable 'ps' invocation - not found")
ENDIF (NOT PS_COMMAND)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)

set(kdbg_SRCS
    pgmargs.cpp
    procattach.cpp
    debugger.cpp
    dbgdriver.cpp
    gdbdriver.cpp
    brkpt.cpp
    exprwnd.cpp
    regwnd.cpp
    memwindow.cpp
    threadlist.cpp
    sourcewnd.cpp
    winstack.cpp
    ttywnd.cpp
    typetable.cpp
    prefdebugger.cpp
    prefmisc.cpp
    pgmsettings.cpp
    watchwindow.cpp
    dbgmainwnd.cpp
    main.cpp
)

set(kdbg_UI
    brkptbase.ui
    brkptcondition.ui
    pgmargsbase.ui
    procattachbase.ui
)

ki18n_wrap_ui(kdbg_SRCS ${kdbg_UI})

file(GLOB ICONS_SRCS "${CMAKE_CURRENT_SOURCE_DIR}/pics/*-apps-kdbg.png")
ecm_add_app_icon(kdbg_SRCS ICONS ${ICONS_SRCS})
add_executable(kdbg ${kdbg_SRCS})

IF (HAVE_LIB_UTIL)
    set(LIB_UTIL util)
ENDIF (HAVE_LIB_UTIL)

target_link_libraries(kdbg
    KF${BUILD_FOR_KDE_VERSION}::I18n
    KF${BUILD_FOR_KDE_VERSION}::ConfigCore
    KF${BUILD_FOR_KDE_VERSION}::CoreAddons
    KF${BUILD_FOR_KDE_VERSION}::IconThemes
    KF${BUILD_FOR_KDE_VERSION}::WindowSystem
    KF${BUILD_FOR_KDE_VERSION}::XmlGui
    ${LIB_UTIL}
)
if(BUILD_FOR_KDE_VERSION EQUAL 6)
    target_link_libraries(kdbg
        Qt::Core5Compat
    )
endif()

install(TARGETS kdbg ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
install(FILES kdbg.desktop DESTINATION ${KDE_INSTALL_APPDIR})
install(FILES kdbgrc DESTINATION ${KDE_INSTALL_CONFDIR})
install(FILES kdbgui.rc DESTINATION ${KDE_INSTALL_KXMLGUIDIR}/kdbg)

=== kdbg/pics/CMakeLists.txt ===
include(ECMInstallIcons)

# compress SVG files
file(GLOB svgs RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}"
	"${CMAKE_CURRENT_SOURCE_DIR}/sc-*.svg")
set(svgzs)
foreach(svg ${svgs})
	set(svgz "${CMAKE_CURRENT_BINARY_DIR}/${svg}z")
	add_custom_command(
		OUTPUT "${svgz}"
		COMMAND gzip < "${CMAKE_CURRENT_SOURCE_DIR}/${svg}" > "${svgz}"
		DEPENDS "${svg}"
	)
	set(svgzs ${svgzs} "${svgz}")
endforeach(svg)
add_custom_target(generatesvgz ALL DEPENDS ${svgzs})

# line items and other pictograms
set(PICTOGRAMS
	brkena.png
	brkdis.png
	brktmp.png
	brkcond.png
	brkorph.png
	pcinner.png
	pcup.png
	watchena.png
	watchdis.png
	pointer.xpm)

install(FILES ${PICTOGRAMS} DESTINATION "${KDE_INSTALL_DATADIR}/kdbg/pics")

ecm_install_icons(ICONS
    16-apps-kdbg.png
    32-apps-kdbg.png
    48-apps-kdbg.png
    64-apps-kdbg.png
    128-apps-kdbg.png
    ${CMAKE_CURRENT_BINARY_DIR}/sc-apps-kdbg.svgz
    DESTINATION "${KDE_INSTALL_ICONDIR}"
    THEME hicolor
)
ecm_install_icons(ICONS
    16-actions-brkpt.png
    16-actions-debug-run.png
    16-actions-executable-open.png
    22-actions-brkpt.png
    22-actions-debug-run.png
    22-actions-executable-open.png
    22-actions-pulse.mng
    32-actions-brkpt.png
    32-actions-debug-run.png
    32-actions-executable-open.png
    48-actions-brkpt.png
    48-actions-debug-run.png
    48-actions-executable-open.png
    ${CMAKE_CURRENT_BINARY_DIR}/sc-actions-brkpt.svgz
    ${CMAKE_CURRENT_BINARY_DIR}/sc-actions-debug-run.svgz
    ${CMAKE_CURRENT_BINARY_DIR}/sc-actions-executable-open.svgz
    DESTINATION "${KDE_INSTALL_DATADIR}/kdbg/icons"
    THEME hicolor
)

=== kdbg/testprogs/Makefile ===
CXXFLAGS=-O0 -g

QMAKE := $(shell which qmake5 qmake-qt5 qmake6 qmake-qt6 qmake 2>/dev/null | head -n1)
QTVERSION := $(shell $(QMAKE) -query QT_VERSION | sed -e 's/\..*//')
QTINC := -I$(shell $(QMAKE) -query QT_INSTALL_HEADERS) -fPIC
QTLIB := $(shell $(QMAKE) -query QT_INSTALL_LIBS)/libQt$(QTVERSION)Core.so

PROGS = \
	anonstruct \
	funcnames \
	helloworld \
	locals \
	longdouble \
	maths \
	multibrkpt \
	nestedclass \
	qt \
	repeats \
	std \
	templates \
	testfile \
	tooltips \
	widechar

all: $(PROGS)

anonstruct: anonstruct.cpp
	g++ -o $@ $(CXXFLAGS) $^

funcnames: funcnames.cpp
	g++ --std=c++11 -o $@ $(CXXFLAGS) $^

helloworld: helloworld.asm
	nasm -f elf64 -F dwarf -g $^ -o $(^:.asm=.o)
	ld -g -o $@ $(^:.asm=.o)

locals: locals.cpp
	g++ -o $@ $(CXXFLAGS) $^

longdouble: longdouble.c
	gcc -o $@ $(CXXFLAGS) $^

maths: maths.cpp
	g++ -o $@ $(CXXFLAGS) $^

multibrkpt: multibrkpt.cpp
	g++ -o $@ $(CXXFLAGS) $^

nestedclass: nestedclass.cpp
	g++ -o $@ $(CXXFLAGS) $^

qt: qt.cpp
	g++ -o $@ $(CXXFLAGS) $^ $(QTINC) $(QTLIB)

repeats: repeats.cpp
	g++ -o $@ $(CXXFLAGS) $^ $(QTINC) $(QTLIB)

std: std.cpp
	g++ -o $@ $(CXXFLAGS) $^

templates: templates.cpp
	g++ -std=c++0x -o $@ $(CXXFLAGS) $^

testfile: testfile.cpp
	g++ -o $@ $(CXXFLAGS) $^ $(QTINC) $(QTLIB)

tooltips: tooltips.cpp
	g++ -o $@ $(CXXFLAGS) $^

widechar: widechar.cpp
	g++ -o $@ $(CXXFLAGS) $^


clean:
	$(RM) $(PROGS)

=== kdbg/typetables/CMakeLists.txt ===
install(FILES
	qt.kdbgtt
	qt2.kdbgtt
	qt3.kdbgtt
	qt4core.kdbgtt
	qt5core.kdbgtt
	kdecore.kdbgtt
	kdecore3.kdbgtt
	glib.kdbgtt
	gtk+.kdbgtt
	stdc++.kdbgtt
	stdc++6.kdbgtt
	X11.kdbgtt
	DESTINATION ${KDE_INSTALL_DATADIR}/kdbg/types)

=== kdbg/doc/de/CMakeLists.txt ===
install(FILES
	argspwdenv.html
	breakptlist.html
	globaloptions.html
	howdoi.html
	localvars.html
	memory.html
	pgmoutput.html
	pgmsettings.html
	registers.html
	sourcecode.html
	stack.html
	threads.html
	tips.html
	watches.html
	index.html
	DESTINATION ${KDE_INSTALL_DOCBUNDLEDIR}/de/kdbg)

=== kdbg/doc/en/CMakeLists.txt ===
install(FILES
	argspwdenv.html
	breakptlist.html
	globaloptions.html
	howdoi.html
	invocation.html
	localvars.html
	memory.html
	pgmoutput.html
	pgmsettings.html
	registers.html
	sourcecode.html
	stack.html
	threads.html
	tips.html
	types.html
	watches.html
	index.html
	DESTINATION ${KDE_INSTALL_DOCBUNDLEDIR}/en/kdbg)

=== kdbg/doc/ru/CMakeLists.txt ===
install(FILES
	argspwdenv.html
	breakptlist.html
	globaloptions.html
	howdoi.html
	localvars.html
	memory.html
	pgmoutput.html
	pgmsettings.html
	registers.html
	sourcecode.html
	stack.html
	threads.html
	tips.html
	watches.html
	index.html
	DESTINATION ${KDE_INSTALL_DOCBUNDLEDIR}/ru/kdbg)

=== debian/changelog ===
kdbg (3.2.0-1) unstable; urgency=medium

  * Release KDbg 3.2.0.

 -- Johannes Sixt <j6t@kdbg.org>  Sun, 16 Aug 2025 17:49:00 +0200

kdbg (3.1.0-1) unstable; urgency=medium

  * Release KDbg 3.1.0.

 -- Johannes Sixt <j6t@kdbg.org>  Sun, 3 Dec 2023 18:45:00 +0100

kdbg (3.0.1-1) unstable; urgency=medium

  * Release KDbg 3.0.1.

 -- Johannes Sixt <j6t@kdbg.org>  Wed, 1 Jan 2020 10:01:45 +0100

kdbg (2.5.5-3) unstable; urgency=medium

  * QA upload.
  * Upload to unstable.

 -- Adrian Bunk <bunk@debian.org>  Sun, 18 Jun 2017 17:23:43 +0300

kdbg (2.5.5-2) experimental; urgency=medium

  * QA upload.
  * debian/copyright: Change my entry to new id.
  * debian/patches:
    - 11_fix_changelog_encoding.patch: Reproducible build. This patch will close
      the bug number #823393 when uploaded to unstable.
  * debian/rules:
    - override_dh_installchangelogs: Add -a parameter to egrep
      (don't use binary mode).

 -- Samuel Henrique <samueloph@gmail.com>  Sat, 20 Aug 2016 21:45:21 -0300

kdbg (2.5.5-1) unstable; urgency=medium

  * QA upload.
  * New upstream release.
  * Update to DH 9.
  * debian/clean: Add debian/upstream.changes.
  * debian/control:
    - Standards-Version: Update to 3.9.8.
    - Remove mention to non existent package (closes: #764423).
  * debian/copyright:
    - Update format to 1.0.
    - Update source's copyright year.
    - Remove trailing whitespace.
  * debian/rules:
    - Export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed so building may avoid
      useless dependencies.
    - Add hardening=+all.
    - override_dh_installchangelogs: Concatenate upstream changelogs into one
      single file at debian/upstream.changes.
    - Remove garbage comment.
  * debian/watch: Update to version 4.

 -- Samuel Henrique Oltramari Pinto (SamuelOPH) <samueloph@gmail.com>  Tue, 19 Apr 2016 01:23:10 -0300

kdbg (2.5.4-2) unstable; urgency=medium

  * QA upload.
  * Orphan package, see #803878.
    - Set maintainer to Debian QA Group.
  * Fix FTBFS. Thanks to Eriberto Mota. (Closes: #808760)
  * Update Standards-Version to 3.9.6, no changes required.
  * Add watch file. Thanks to Bart Martens.

 -- Ana Beatriz Guerrero Lopez <ana@debian.org>  Wed, 16 Mar 2016 23:42:03 +0100

kdbg (2.5.4-1) unstable; urgency=medium

  * New upstream release.

 -- Ana Beatriz Guerrero Lopez <ana@debian.org>  Fri, 29 Nov 2013 19:40:20 +0100

kdbg (2.5.3-1) unstable; urgency=low

  * New upstream release. (Closes: #715031)
  * Update Standards-Version to 3.9.4, no changes required.

 -- Ana Beatriz Guerrero Lopez <ana@debian.org>  Mon, 15 Jul 2013 20:08:45 +0200

kdbg (2.5.1-1) unstable; urgency=low

  * New upstream release. (Closes: #672338)

 -- Ana Beatriz Guerrero Lopez <ana@debian.org>  Thu, 10 May 2012 21:01:19 +0200

kdbg (2.5.0-1) unstable; urgency=low

  * New upstream release.

 -- Ana Beatriz Guerrero Lopez <ana@debian.org>  Sat, 02 Apr 2011 23:39:51 +0200

kdbg (2.4.92~1-1) unstable; urgency=low

  * Git Snapshot of a future 2.5 release, now ported to KDE 4. This means
    significant changes in the packaging. (Closes: #604333)
  * We used cmake now, no outdated config.{sub,guess} anymore. (Closes: #582436)
  * Remove suggests on kxsldbg, it is not in the Debian archive anymore.
  * Update years in copyright file.

 -- Ana Beatriz Guerrero Lopez <ana@debian.org>  Sat, 12 Mar 2011 17:00:01 +0100

kdbg (2.2.1-2) unstable; urgency=low

  * Redone again relibtoolization making sure it uses latest automake.
    (Closes: #577679)

 -- Ana Beatriz Guerrero Lopez <ana@debian.org>  Wed, 21 Apr 2010 04:31:55 +0200

kdbg (2.2.1-1) unstable; urgency=low

  * New upstream release.
  * Redone libtoolization.
  * Remove patch 03_fix_ftbfs, merged upstream.
  * Update Standards-Version to 3.8.4, no changes required.
  * Add ${misc:Depends} to Depends:

 -- Ana Beatriz Guerrero Lopez <ana@debian.org>  Sat, 10 Apr 2010 18:39:35 +0200

kdbg (2.2.0-2) unstable; urgency=low

  * Add patch taken from upstream to fix FTBFS with newer glibc 2.10 and gcc 4.4.
   (Closes: #552582)
  * Minor updates in the copyright file.

 -- Ana Beatriz Guerrero Lopez <ana@debian.org>  Thu, 19 Nov 2009 23:06:37 +0100

kdbg (2.2.0-1) unstable; urgency=low

  * New upstream release.
  * Redone libtoolization.
  * Update Standards-Version to 3.8.3, no changes required.

 -- Ana Beatriz Guerrero Lopez <ana@debian.org>  Sun, 20 Sep 2009 20:41:52 +0200

kdbg (2.1.1-1) unstable; urgency=low

  * New upstream release:
    - Do not crash when clicking on "delete" button if not program is loaded.
      (Closes: #467243)
  * Redo patches: 02_libtool_update.diff and buildprep.
  * Update upstream's email in copyright file.
  * Update copyright years.
  * Update Section in doc-base.

 -- Ana Beatriz Guerrero Lopez <ana@debian.org>  Mon, 29 Dec 2008 13:24:32 +0100

kdbg (2.1.0-2) unstable; urgency=low

  * Remove unnecessary build dependency on libqt3-compat-headers. 
    (Closes: #464057) 

 -- Ana Beatriz Guerrero Lopez <ana@debian.org>  Thu, 07 Feb 2008 11:10:15 +0100

kdbg (2.1.0-1) unstable; urgency=low

   * New upstream release.
   * Update Standards-Version to 3.7.3.
   * Move homepage into control field.
   * Update menu file to new policy.

 -- Ana Beatriz Guerrero Lopez <ana@debian.org>  Wed, 26 Dec 2007 04:52:24 +0100

kdbg (2.0.5-2) unstable; urgency=low

  * Rewrite debian/rules. Now it can be built twice in a row. 
   (Closes: #424429)
  * Dangling symlinks are not longer created. (Closes: #186169)
  * Redone relibtoolization. (Closes: #418563).

 -- Ana Beatriz Guerrero Lopez <ana@debian.org>  Wed, 30 May 2007 01:13:37 +0100

kdbg (2.0.5-1) unstable; urgency=low

  * New upstream release.

 -- Ana Beatriz Guerrero Lopez <ana@debian.org>  Tue, 19 Dec 2006 02:15:51 +0100

kdbg (2.0.4-3) unstable; urgency=low
  
  * Bumped compat to 5.
  * Added space to homepage pseudo header.

 -- Ana Beatriz Guerrero Lopez <ana@debian.org>  Sat, 28 Oct 2006 03:57:29 +0200

kdbg (2.0.4-2) unstable; urgency=medium



=== debian/control ===
Source: kdbg
Section: devel
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper (>=9), cmake (>= 3.16),
 extra-cmake-modules (>= 5.101.0),
 libkf5config-dev (>= 5.101.0) | libkf6config-dev (>= 6.6.0),
 libkf5i18n-dev (>= 5.101.0) | libkf6i18n-dev (>= 6.6.0),
 libkf5iconthemes-dev (>= 5.101.0) | libkf6iconthemes-dev (>= 6.6.0),
 libkf5windowsystem-dev (>= 5.101.0) | libkf6windowsystem-dev (>= 6.6.0),
 libkf5xmlgui-dev (>= 5.101.0) | libkf6xmlgui-dev (>= 6.6.0),
 nasm
Standards-Version: 3.9.8
Homepage: http://www.kdbg.org/

Package: kdbg
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: gdb (>= 5.0)
Description: graphical debugger interface
 KDbg is a graphical user interface to gdb, the GNU debugger.  It provides
 an intuitive interface for setting breakpoints, inspecting variables,
 stepping through code and much more.  KDbg requires KDE but you can of
 course debug any program.
 .
 Features include the following:
  * Inspection of variable values in a tree structure.
  * Direct member: For certain compound data types the most important
    member values are displayed next to the variable name, so that it is
    not necessary to expand the subtree of that variable in order to see
    the member value.  KDbg can also display Qt's QString values, which
    are Unicode strings.
  * Debugger at your finger tips: The basic debugger functions (step,
    next, run, finish, until, set/clear/enable/disable breakpoint) are
    bound to function keys F5 through F10.  Quick and easy.
  * View source code, search text, set program arguments and environment
    variables, display arbitrary expressions.
  * Debugging of core dumps, attaching to running processes is possible.
  * Conditional breakpoints.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_installchangelogs:
	cat ReleaseNotes-* \
		$$(ls kdbg/doc/relnotes/ReleaseNotes-* | sort -Vr) \
		kdbg/doc/relnotes/ChangeLog-pre-2.2.0 | \
	   egrep -av '(KDbg Release Notes for|====)' > debian/upstream.changes
	dh_installchangelogs debian/upstream.changes
